;    .
;  :  .., 11.02.2004

;    

(defun load_bases_symb_codes (file_name)
 (setq bases_symb_codes_list nil)
 (rds file_name)
 (loop
    ((not (listen)))
    (setq bases_symb_codes_list (cons (read-line) bases_symb_codes_list)))
 (rds) bases_symb_codes_list)

;    

(defun load_bases_numbers (file_name)
 (setq bases_numbers_list nil)
 (rds file_name)
 (loop
    ((not (listen)))
    (setq bases_numbers_list (cons (read-line) bases_numbers_list)))
 (rds) bases_numbers_list)

;      

(defun load_basechange_classes (file_name)
 (setq basechange_class_list nil)
 (rds file_name)
 (loop
    ((not (listen)))
    (setq basechange_class_list (cons (read-line) basechange_class_list)))
 (rds) basechange_class_list)

;      

(defun load_flect_classes (file_name)
 (setq flect_class_list nil)
 (rds file_name)
 (loop
    ((not (listen)))
    (setq flect_class_list (cons (read-line) flect_class_list)))
 (rds) flect_class_list)

;     

;      

(defun db_make (db_name props vals)

;        
 (
  (or
   (and (null props)(not (null vals)))
   (and (not (null props))(null vals))
  ) nil)

;   
 (
  (and (null (cdr props))(null (cdr vals)))
  (put db_name (car props)(car vals))
 )
 (
  (put db_name (car props)(car vals))
  (db_make db_name (cdr props)(cdr vals))
 )
)

;        

(defun db_complex_props_make (db_name props vals vals_of_props_list)

; db_name -  
; props -     
; vals -     
; vals_of_props_list -     
;                      (<> <  >)

 ((null vals_of_props_list)(db_make db_name props vals))
 ((db_make db_name props vals)(complex_props_make vals vals_of_props_list))
)

;   

(defun complex_props_make (vals vals_of_props_list)
 (
  (and (null (cdr vals))
       (not (null vals_of_props_list))
  )
  (complex_prop_make (car vals) vals_of_props_list)
 )
 (
  (complex_prop_make (car vals) vals_of_props_list)
  (complex_props_make (cdr vals)(vals_of_props_make vals_of_props_list))
 )
)

(defun complex_prop_make (val vals_of_props_list)
 (
  (null (cdr vals_of_props_list))
  (put val (caar vals_of_props_list)
           (caadar vals_of_props_list)
  )
 )
 ((put val (caar vals_of_props_list)
           (caadar vals_of_props_list)
  )
  (complex_prop_make val (cdr vals_of_props_list))
 )
)

;        
;   

(defun vals_of_props_make (vals_of_props_list)
 ((null vals_of_props_list) nil)
 (cons (list (caar vals_of_props_list)(cdadar vals_of_props_list))
       (vals_of_props_make (cdr vals_of_props_list))
 )
)

(defun test5 (db_name obj1 obj2)
 (db_complex_props_make db_name bases_symb_codes_list
                     bases_numbers_list
                     (list
                      (list obj1 basechange_class_list)
                      (list obj2 flect_class_list)
                     )
 )
)

(rds)